//recaptcha
//prod 6LcViu8UAAAAAPMqcSPkfys4z7RDEf0vvrbpneaU
//regaloeb 6LdRt_EUAAAAAAYvawHW4ExIVWYYGd72s6sEQc_t
var renderRecaptcha = function () {  
	grecaptcha.render('recaptcha-container', {  
		'sitekey': '6LdRt_EUAAAAAAYvawHW4ExIVWYYGd72s6sEQc_t',  
		'callback': reCaptchaCallback,  
		theme: 'light', //light or dark    
		//type: 'image',// image or audio    
		size: 'normal'//normal or compact    
	});  
};  

var reCaptchaCallback = function (response) {  
	if (response !== '') {  
		var elt = document.querySelector('.form-line.captcha');
		elt.classList.remove('error');
		var errorP = elt.querySelector('.error');
		if(errorP){
			errorP.classList.remove('error');
			errorP.innerHTML = '';
		} 
	}  
};
(function () {
	////////// FORMS
	//is mobile
	var isMobile = { 
		Android: function() { return navigator.userAgent.match(/Android/i); }, 
		BlackBerry: function() { return navigator.userAgent.match(/BlackBerry/i); }, 
		iOS: function() { return navigator.userAgent.match(/iPhone|iPad|iPod/i); }, 
		Opera: function() { return navigator.userAgent.match(/Opera Mini/i); }, 
		Windows: function() { return navigator.userAgent.match(/IEMobile/i); }, 
		any: function() { return (isMobile.Android() || isMobile.BlackBerry() || isMobile.iOS() || isMobile.Opera() || isMobile.Windows()); } 
	};
	//valid forms
	function validateEmail(email) {
		var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
		return re.test(email);
	}
	var regExpressions = {
		'pwd': /^[a-zA-Z0-9]{5,}$/,      /* minimum 5 caractères alphanumériques */
		'zipcode' : /^[0-9]{5}$/,      /* 5 chiffres */
		'phoneNumber' : /^[0-9]{10,}$/,      /* minimum 10 chiffres */
		'integer': /^\d+$/,      /* pas de caractères alpha */
		'email': /\S+@\S+\.\S+/,      /* e-mail simplifié */
		'empty':/^\s*$/,
		//'date': /^(0[1-9]|[12][0-9]|3[01])[- /.](0[1-9]|1[012])[- /.](19|20)\d\d$/	/* dd/mm/yyy 01 à 31/01 à 12/ 1900 à 2099*/,
		'date': /^^\d{4}\-(0[1-9]|1[012])\-(0[1-9]|[12][0-9]|3[01])$/	/* yyyy-mm-dd */
	}
	var isEmail = function(string){
		//returns true if string is email
		//return regExpressions.email.test(string);
		return validateEmail(string);
	}
	var isEmpty = function(string){
		//returns true if string is empty
		return regExpressions.empty.test(string);
	}
	var isNumber = function(string){
		//returns true if string is a number
		return regExpressions.integer.test(string);
	}
	var isDate = function(string){
		//returns true if string is a number
		return regExpressions.date.test(string);
	}
	function detectIE() {
		var ua = window.navigator.userAgent;
		// Test values; Uncomment to check result …
		// IE 10
		// ua = 'Mozilla/5.0 (compatible; MSIE 10.0; Windows NT 6.2; Trident/6.0)';
		// IE 11
		// ua = 'Mozilla/5.0 (Windows NT 6.3; Trident/7.0; rv:11.0) like Gecko';
		// Edge 12 (Spartan)
		// ua = 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.71 Safari/537.36 Edge/12.0';
		// Edge 13
		// ua = 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/46.0.2486.0 Safari/537.36 Edge/13.10586';
		var msie = ua.indexOf('MSIE ');
		if (msie > 0) {
			// IE 10 or older => return version number
			return parseInt(ua.substring(msie + 5, ua.indexOf('.', msie)), 10);
		}

		var trident = ua.indexOf('Trident/');
		if (trident > 0) {
			// IE 11 => return version number
			var rv = ua.indexOf('rv:');
			return parseInt(ua.substring(rv + 3, ua.indexOf('.', rv)), 10);
		}

		var edge = ua.indexOf('Edge/');
		if (edge > 0) {
			// Edge (IE 12+) => return version number
			return parseInt(ua.substring(edge + 5, ua.indexOf('.', edge)), 10);
		}
		// other browser
		return false;
	}
	//check if browser recognize correctly input-date
	function checkDateInput() {
		var input = document.createElement('input');
		input.setAttribute('type','date');
		var notADateValue = 'not-a-date';
		input.setAttribute('value', notADateValue); 
		return (input.value !== notADateValue);
	}
	//IE Edge input-date doesn't have reset button, so we create one for him!
	if(detectIE() && checkDateInput()){
		document.querySelectorAll('.input-date input[type=date]').forEach(function(elt){
			var resetBtn = document.createElement('a');
			resetBtn.setAttribute('class', 'reset');
			resetBtn.setAttribute('href', '#');
			elt.parentElement.appendChild(resetBtn);
		});
		document.querySelectorAll('.input-date .reset').forEach(function(elt){
			elt.onclick = function(e){
				e.preventDefault();
				e.currentTarget.parentElement.querySelector('input').value = '';
			};
		});
	}
	//customized select => /javascripts/plugins.js (vanilla-js-dropdown)
	document.querySelectorAll('select').forEach(function(elt){
		new CustomSelect({elem:elt});
	});
	
	//input focus
	document.querySelectorAll('.input-text input').forEach(function(elt){
		elt.onfocus = function(e){
			var that = e.currentTarget;
			that.parentElement.classList.add('focus');
			that.parentElement.classList.remove('filled');
			that.parentElement.classList.remove('error');
			var errorP = that.parentElement.querySelector('.error');
			if(errorP){
				errorP.innerHTML = '';
			}
		};
	});
	//input blur
	document.querySelectorAll('.input-text input').forEach(function(elt){
		elt.onblur = function(e){
			var that = e.currentTarget;
			if(isEmpty(that.value)){
				that.parentElement.classList.remove('focus');
			}
			else{
				that.parentElement.classList.remove('focus');
				that.parentElement.classList.add('filled');
			}
			//email
			if(that.getAttribute('type') === 'email'){
				if(!isEmpty(that.value) && !isEmail(that.value)){
					//if not empty must be a valid email
					that.parentElement.classList.add('error');
					if(that.parentElement.querySelector('.error')){
						that.parentElement.querySelector('.error').innerHTML = that.parentElement.querySelector('.error').getAttribute('data-text');
					}
				}
			}
		}
	});
	//input default state
	document.querySelectorAll('.input-text input').forEach(function(elt){
		if(!isEmpty(elt.value)){
			elt.parentElement.classList.add('filled');
		}
	});
	
	//allow only numbers in input[type=number] because alpha is displayed but value is empty
	document.querySelectorAll('.input-text input[type=number]').forEach(function(elt){
		elt.onkeypress = function(e){
			e = (e) ? e : window.event;
			var charCode = (e.which) ? e.which : e.keyCode;
			if (charCode > 31 && (charCode < 48 || charCode > 57)) {
				return false;
			}
			return true;
		}
	});
	
	//verif mandatory input-text onblur
	document.querySelectorAll('.input-text input.js-mandatory').forEach(function(elt){
		elt.onblur = function(e){
			var that = e.currentTarget;
			//text
			if(that.getAttribute('type') === 'text' || 'number' || 'tel' || 'password'){
				if(isEmpty(that.value)){
					that.parentElement.classList.remove('focus');
					that.parentElement.classList.add('error');
					var errorP = that.parentElement.querySelector('.error');
					if(errorP){
						errorP.innerHTML = errorP.getAttribute('data-text');
					}
				}
			}
			//email
			if(that.getAttribute('type') === 'email'){
				if(isEmpty(that.value)){
					that.parentElement.classList.remove('focus');
					that.parentElement.classList.add('error');
					var errorP = that.parentElement.querySelector('.error');
					if(errorP){
						errorP.innerHTML = errorP.getAttribute('data-text');
					}
				}
				else if(!isEmail(that.value)){
					that.parentElement.classList.add('focus');
					that.parentElement.classList.add('error');
					var errorP = that.parentElement.querySelector('.error');
					if(errorP){
						errorP.innerHTML = errorP.getAttribute('data-text');
					}
				}
			}
			//date
			if(that.getAttribute('type') === 'date'){
				if(isEmpty(that.value)){
					that.parentElement.classList.remove('focus');
					that.parentElement.classList.remove('filled');
					that.parentElement.classList.add('error');
					var errorP = that.parentElement.querySelector('.error');
					if(errorP){
						errorP.innerHTML = errorP.getAttribute('data-text');
					}
				}
				else if(!isDate(that.value)) {
					that.parentElement.classList.add('focus');
					that.parentElement.classList.add('error');
					var errorP = that.parentElement.querySelector('.error');
					if(errorP){
						errorP.innerHTML = errorP.getAttribute('data-text');
					}
				}
				else{
					that.parentElement.classList.remove('focus');
					if(isMobile.any()){
						that.parentElement.classList.add('filled');
					}
				}
			}
		}
	});
	//verif mandatory input-date onchange
	if(checkDateInput()){
		document.querySelectorAll('.input-date input.js-mandatory').forEach(function(elt){
			elt.onchange = function(e){
				var that = e.currentTarget || e.target;
				if(!isMobile.iOS()){
					that.blur();
				}
				if(isEmpty(that.value)){
					that.parentElement.classList.remove('focus');
					that.parentElement.classList.add('error');
					var errorP = that.parentElement.querySelector('.error');
					if(errorP){
						errorP.innerHTML = errorP.getAttribute('data-text');
					}
				}
				else if(!isDate(that.value)) {
					that.parentElement.classList.remove('focus');
					that.parentElement.classList.add('filled');
					that.parentElement.classList.add('error');
					var errorP = that.parentElement.querySelector('.error');
					if(errorP){
						errorP.innerHTML = errorP.getAttribute('data-text');
					}
				}
				else{
					that.parentElement.classList.remove('focus');
					if(isMobile.any()){
						that.parentElement.classList.add('filled');
					}
				}
			}
		});
		document.querySelectorAll('.input-date input:not(.js-mandatory)').forEach(function(elt){
			elt.onchange = function(e){
				var that = e.currentTarget || e.target;
				if(!isMobile.iOS()){
					that.blur();
				}
			}
		});
	}
	document.querySelectorAll('.input-text input.js-mandatory').forEach(function(elt){
		elt.onfocus = function(e){
			var that = e.currentTarget;
			that.parentElement.classList.add('focus');
			that.parentElement.classList.remove('error');
			var errorP = that.parentElement.querySelector('.error');
			if(errorP){
				errorP.innerHTML = '';
			}
		}
	});
	
	//verif mandatory checked-box onmouseup
	document.querySelectorAll('.input-check.input-mandatory').forEach(function(elt){
		elt.onmouseup = function(e){
			var that = e.currentTarget;
			if(!that.querySelectorAll('input:checked').length){ 
				// condition inverted because checkbox hasn't yet changed its state when mouseup targeted...
				that.classList.remove('error');
				var errorP = that.querySelector('.error');
				if(errorP){
					errorP.innerHTML = '';
				}
			}
			else{
				that.classList.add('error');
				var errorP = that.querySelector('.error');
				if(errorP){
					errorP.innerHTML = errorP.getAttribute('data-text');
				}
			}
		}
	});
	
	//textarea focus
	document.querySelectorAll('.textarea textarea').forEach(function(elt){
		elt.onfocus = function(e){
			var that = e.currentTarget;
			that.parentElement.classList.add('focus');
			that.parentElement.classList.remove('error');
			var errorP = that.parentElement.querySelector('.error');
			if(errorP){
				errorP.innerHTML = '';
			}
		}
	});
	//textarea blur
	document.querySelectorAll('.textarea textarea:not(.js-mandatory)').forEach(function(elt){
		elt.onblur = function(e){
			var that = e.currentTarget;
			if(isEmpty(that.value)){
				that.parentElement.classList.remove('focus');
			}
			else {
				that.parentElement.classList.remove('focus');
				that.parentElement.classList.add('filled');
			}
		}
	});
	document.querySelectorAll('.textarea textarea.js-mandatory').forEach(function(elt){
		elt.onblur = function(e){
			var that = e.currentTarget;
			if(isEmpty(that.value)){
				that.parentElement.classList.remove('focus');
				that.parentElement.classList.add('error');
				var errorP = that.parentElement.querySelector('.error');
				if(errorP){
					errorP.innerHTML = errorP.getAttribute('data-text');
				}
			}
			else {
				that.parentElement.classList.remove('focus');
				that.parentElement.classList.add('filled');
			}
		}
	});
	//textarea default state
	document.querySelectorAll('.textarea textarea').forEach(function(elt){
		if(!isEmpty(elt.value)){
			elt.parentElement.classList.add('filled');
		}
	});
	
	//radio 
	document.querySelectorAll('.input-radio input').forEach(function(elt){
		elt.onchange = function(e){
			var that = e.currentTarget;
			that.parentElement.classList.remove('error');
			var errorP = that.parentElement.querySelector('.error');
			if(errorP){
				errorP.innerHTML = '';
			}
		}
	});
	
	//select 
	document.querySelectorAll('.menu-select .js-Dropdown-title').forEach(function(elt){
		elt.onclick = function(e){
			var that = e.currentTarget;
			that.parentElement.parentElement.classList.remove('error');
			var errorP = that.parentElement.parentElement.querySelector('.error');
			if(errorP){
				errorP.innerHTML = '';
			}
		}
	});
	document.querySelectorAll('.menu-select select.js-mandatory').forEach(function(elt){
		elt.onchange = function(e){
			var that = e.currentTarget;
			var val = that.value;
			var errorP = that.parentElement.querySelector('.error');
			if(val === '#'){
				that.parentElement.classList.add('error');
				if(errorP){
					errorP.innerHTML = errorP.getAttribute('data-text');
				}
			}
			else{
				that.parentElement.classList.remove('error');
				if(errorP){
					errorP.innerHTML = '';
				}
			}
		}
	});
	
	//verif saisie input.js-mandatory on form.submit
	document.querySelectorAll('.js-submit').forEach(function(eltSubmit){
		eltSubmit.onclick = function(e){
			var validSubmit = true;
			var formSubmit = eltSubmit.closest('form');
			formSubmit.querySelectorAll('input.js-mandatory').forEach(function(elt){
				//text
				if(elt.getAttribute('type') === 'text' || 'number' || 'tel' || 'password'){
					if(isEmpty(elt.value)){
						validSubmit = false;
						elt.parentElement.classList.remove('focus');
						elt.parentElement.classList.add('error');
						var errorP = elt.parentElement.querySelector('.error');
						if(errorP){
							errorP.innerHTML = errorP.getAttribute('data-text');
						}
					}
				}
				//email
				if(elt.getAttribute('type') === 'email'){
					if(isEmpty(elt.value)){
						validSubmit = false;
						elt.parentElement.classList.remove('focus');
						elt.parentElement.classList.add('error');
						var errorP = elt.parentElement.querySelector('.error');
						if(errorP){
							errorP.innerHTML = errorP.getAttribute('data-text');
						}
					}
					if(!isEmpty(elt.value) && !isEmail(elt.value)){
						validSubmit = false;
						elt.parentElement.classList.add('focus');
						elt.parentElement.classList.add('error');
						var errorP = elt.parentElement.querySelector('.error');
						if(errorP){
							errorP.innerHTML = errorP.getAttribute('data-text');
						}
					}
				}
				//date
				if(elt.getAttribute('type') === 'date'){
					if(isEmpty(elt.value)){
						validSubmit = false;
						elt.parentElement.classList.remove('focus');
						elt.parentElement.classList.add('error');
						var errorP = elt.parentElement.querySelector('.error');
						if(errorP){
							errorP.innerHTML = errorP.getAttribute('data-text');
						}
					}
					else if(!isDate(elt.value)) {
						validSubmit = false;
						elt.parentElement.classList.add('focus');
						elt.parentElement.classList.add('error');
						var errorP = elt.parentElement.querySelector('.error');
						if(errorP){
							errorP.innerHTML = errorP.getAttribute('data-text');
						}
					}
				}
			});
			formSubmit.querySelectorAll('.input-text input[type=email]:not(.mandatory)').forEach(function(elt){
				//email
				if(!isEmpty(elt.value) && !isEmail(elt.value)){
					//if not empty must be a valid email
					elt.parentElement.classList.add('error');
					var errorP = elt.parentElement.querySelector('.error');
					if(errorP){
						errorP.innerHTML = errorP.getAttribute('data-text');
					}
				}
			});
			//checkbox
			formSubmit.querySelectorAll('.input-check.input-mandatory').forEach(function(elt){
				if(!elt.querySelectorAll('input:checked').length){ 
					validSubmit = false;
					elt.classList.add('error');
					var errorP = elt.querySelector('.error');
					if(errorP){
						errorP.innerHTML = errorP.getAttribute('data-text');
					}
				}
			});
			//radio
			formSubmit.querySelectorAll('.input-radio.input-mandatory').forEach(function(elt){
				if(!elt.querySelectorAll('input:checked').length){ 
					validSubmit = false;
					elt.classList.add('error');
					var errorP = elt.querySelector('.error');
					if(errorP){
						errorP.innerHTML = errorP.getAttribute('data-text');
					}
				}
			});
			//textarea
			formSubmit.querySelectorAll('.textarea textarea.js-mandatory').forEach(function(elt){
				if(isEmpty(elt.value)){
					validSubmit = false;
					elt.parentElement.classList.remove('focus');
					elt.parentElement.classList.add('error');
					var errorP = elt.parentElement.querySelector('.error');
					if(errorP){
						errorP.innerHTML = errorP.getAttribute('data-text');
					}
				}
			});
			//select
			formSubmit.querySelectorAll('.menu-select select.js-mandatory').forEach(function(elt){
				var val = elt.value;
				if(val === '#'){
					validSubmit = false;
					elt.parentElement.classList.add('error');
					var errorP = elt.parentElement.querySelector('.error');
					if(errorP){
						errorP.innerHTML = errorP.getAttribute('data-text');
					}
				}
			});
			//recaptcha
			formSubmit.querySelectorAll('.captcha').forEach(function(elt){
				var recaptchaValid = false;
				if (typeof (grecaptcha) != 'undefined') {  
					var response = grecaptcha.getResponse(); 
					if(response.length === 0){
						validSubmit = false;
						elt.classList.add('error');
						var errorP = elt.querySelector('.error');
						if(errorP){
							errorP.innerHTML = errorP.getAttribute('data-text');
						}
					}
				}
			});
			
			if(!validSubmit){
				e.preventDefault();
				eltSubmit.classList.add('error');
				var errorP = eltSubmit.parentElement.querySelector('.submit-error');
				if(errorP){
					errorP.innerHTML = errorP.getAttribute('data-text');
				}
				setTimeout(function(){
					eltSubmit.classList.remove('error');
				}, 2000);
			}
		}
	});
	////////// END FORMS
})();

